define("io.ox/office/tk/locale/parser",["io.ox/office/tk/utils","io.ox/office/tk/object/arraytemplate","io.ox/office/tk/locale/localedata"],function(a,b,c){"use strict";function d(a,b,c){this.type=a,this.text=b,this.length=c}function e(){this.tokens=new k,this.dynamic=!1,this.colorName=null,this.rgbColor=null,this.operator=null,this.boundary=0,this.autoMinus=!0,this.percent=0,this.scientific=!1,this.fractional=!1,this.currency=!1,this.dateTime=!1,this.hasAmPm=!1,this.text=!1,this.fill=!1}function f(){this.numberSections=new l,this.textSection=null,this.syntaxError=!1}var g={black:"000000",blue:"0000FF",cyan:"00FFFF",green:"00FF00",magenta:"FF00FF",red:"FF0000",white:"FFFFFF",yellow:"FFFF00"},h=new RegExp("^\\[("+_.keys(g).join("|")+")\\]","i"),i={traditional:{Y:"年",M:"月",D:"日",h:"時",m:"分",s:"秒"},simplified:{Y:"年",M:"月",D:"日",h:"时",m:"分",s:"秒"},hangul:{Y:"년",M:"월",D:"일",h:"시",m:"분",s:"초"}},j=_.memoize(function(a){return a=_.escapeRegExp(a),new RegExp("^([-+]?)((?:\\d*"+a+"\\d+|\\d+"+a+"?)(?:E[-+]?\\d+)?)","i")}),k=b.create(d);e.prototype.pushToken=function(a){this.tokens.push(new d(a,"",0))},e.prototype.pushTextToken=function(a,b){var c=this.tokens.last();c&&c.type===a?c.text+=b:this.tokens.push(new d(a,b,0))},e.prototype.pushLiteralToken=function(a){this.pushTextToken("lit",a)},e.prototype.pushDateTimeToken=function(a,b){this.tokens.push(new d(a,"",b)),this.dateTime=!0},e.prototype.pushAmPmToken=function(a){this.pushDateTimeToken("ampm",a),this.hasAmPm=!0},e.prototype.setColor=function(b){b in g?(this.colorName=b,this.rgbColor=g[b]):a.error('FormatSection.setColor(): invalid color "'+b+'"')},e.prototype.setInterval=function(b,c,d){if(!d||!this.operator){switch(b){case"<":this.autoMinus=c>0;break;case"<=":this.autoMinus=c>=0;break;case">":case">=":this.autoMinus=0>c;break;case"=":this.autoMinus=!1;break;case"<>":this.autoMinus=!0;break;default:return void a.error('FormatSection.setInterval(): invalid interval operator "'+b+'"')}this.operator=b,this.boundary=c}},e.prototype.contains=function(a){switch(this.operator){case"<":return a<this.boundary;case"<=":return a<=this.boundary;case">":return a>this.boundary;case">=":return a>=this.boundary;case"=":return a===this.boundary;case"<>":return a!==this.boundary}return!0},e.parse=function(b){for(var c=new e,d=null,f=!1,g=!1,i=!1;!f&&!g&&b.length>0;)try{if(d=/^;/.exec(b)){g=!0;continue}if(d=/^GENERAL/i.exec(b)){c.pushToken("general"),c.dynamic=!0;continue}if(d=/^\.[0?#]+/i.exec(b)){c.pushTextToken("sign",d[0]),c.fractional=!0;continue}if(d=/^[0?#]+\/[0?#]+/i.exec(b)){c.pushTextToken("frac",d[0]),c.fractional=!0;continue}if(d=/^,?[0#?]+,?/.exec(b)){c.pushTextToken("nr",d[0]);continue}if(d=/^E[-+]([0?#]+)/i.exec(b)){c.pushTextToken("scien",d[1]),c.scientific=!0;continue}if(d=/^AM\/PM/i.exec(b)){c.pushAmPmToken(2);continue}if(d=/^A\/P/i.exec(b)){c.pushAmPmToken(1);continue}if(d=/^Y+/i.exec(b)){c.pushDateTimeToken("year",Math.min(4,a.roundUp(d[0].length,2))),i=!1;continue}if(d=/^M+/.exec(b)){c.pushDateTimeToken("month",Math.min(5,d[0].length)),i=!1;continue}if(d=/^D+/i.exec(b)){c.pushDateTimeToken("day",Math.min(4,d[0].length)),i=!1;continue}if(d=/^\[(h+)\]/i.exec(b)){c.pushDateTimeToken("hours",d[1].length),i=!0;continue}if(d=/^\[(m+)\]/.exec(b)){c.pushDateTimeToken("minutes",d[1].length);continue}if(d=/^\[(s+)\]/i.exec(b)){c.pushDateTimeToken("seconds",d[1].length),i=!1;continue}if(d=/^h+/i.exec(b)){c.pushDateTimeToken("hour",Math.min(2,d[0].length)),i=!0;continue}if(d=/^(m+)(?=\W+s)/i.exec(b)){c.pushDateTimeToken("minute",Math.min(2,d[1].length)),i=!1;continue}if(d=/^m+/.exec(b)){i?c.pushDateTimeToken("minute",Math.min(2,d[0].length)):c.pushDateTimeToken("month",Math.min(5,d[0].length)),i=!1;continue}if(d=/^s+/i.exec(b)){c.pushDateTimeToken("second",Math.min(2,d[0].length)),i=!1;continue}if(d=/^%/.exec(b)){c.pushLiteralToken("%"),c.percent+=1;continue}if(d=/^"([^"]*)"/.exec(b)){c.pushLiteralToken(d[1]);continue}if(d=/^\\(.)/.exec(b)){c.pushLiteralToken(d[1]);continue}if(d=/^_./.exec(b)){c.pushLiteralToken(" ");continue}if(d=/^\*(.)/.exec(b)){c.fill?c.pushLiteralToken(d[1]):(c.pushTextToken("fill",d[1]),c.dynamic=c.fill=!0);continue}if(d=/^\[(<=?|>=?|<>|=)([^[\];]+)\]/.exec(b)){var j=m.parseLeadingNumber(d[2],{dec:".",sign:!0,complete:!0});j&&0===j.remaining.length?c.setInterval(d[1],j.number):f=!0;continue}if(d=h.exec(b)){c.setColor(d[1].toLowerCase());continue}if(d=/^\[\$-([0-9a-f]+)\]/i.exec(b))continue;if(d=/^\[\$([^[\];-]+)-([0-9a-f]+)\]/i.exec(b)){c.pushLiteralToken(d[1]),c.currency=!0;continue}if(d=/^(\[[^[\];]*\])/.exec(b)){a.warn('FormatSection.parse(): unsupported section specifier "'+d[1]+'"');continue}if(d=/^@/.exec(b)){c.pushToken("text"),c.text=!0;continue}if(/^["\[\\_*]/.test(b)){f=!0;continue}d=[b[0]],c.pushLiteralToken(d[0])}finally{b=b.slice(d[0].length)}return{section:f?null:c,remainder:g?b:null}};var l=b.create(e);f.prototype.parseSection=function(a){var b=e.parse(a);return b.section?this.textSection?(this.syntaxError=!0,null):(b.section.text?this.textSection=b.section:this.numberSections.push(b.section),b.remainder):(this.syntaxError=!0,null)},f.prototype.getSection=function(a){return this.syntaxError?null:_.isString(a)?this.textSection:_.isNumber(a)&&isFinite(a)?this.numberSections.find(function(b){return b.contains(a)}):null};var m={};return m.numberToString=function(a){return String(a).replace(/\./g,c.DEC)},m.stringToNumber=function(a){return parseFloat(a.replace(c.DEC,"."))},m.parseLeadingNumber=function(b,d){var e=a.getStringOption(d,"sep",c.DEC),f=a.getBooleanOption(d,"sign",!1),g=a.getBooleanOption(d,"complete",!1),h=j(e).exec(b),i=null;return!h||!f&&h[1].length>0?null:g&&h[0].length<b.length?null:(i=parseFloat(h[2].replace(e,".")),_.isFinite(i)?("-"===h[1]&&(i=-i),{number:i,text:h[0],sign:h[1],remaining:b.substr(h[0].length)}):null)},m.parseFormatCode=_.memoize(function(a){var b=new f;for(b.syntaxError=0===a.length;!b.syntaxError&&_.isString(a);)a=b.parseSection(a);switch(b.numberSections.length){case 0:b.numberSections.push(new e),b.numberSections[0].pushToken("general");break;case 1:break;case 2:b.numberSections[0].setInterval(">=",0,!0),b.numberSections[1].setInterval("<",0,!0);break;case 3:b.numberSections[0].setInterval(">",0,!0),b.numberSections[1].setInterval("<",0,!0),b.numberSections[2].setInterval("=",0,!0);break;default:b.syntaxError=!0}if(b.textSection)b.textSection.operator&&(b.syntaxError=!0);else{b.textSection=new e,b.textSection.pushToken("text");var c=b.numberSections[0];c.colorName&&1===c.tokens.length&&"general"===c.tokens[0].type&&b.textSection.setColor(b.numberSections[0].colorName)}return b}),m.generateCJKDateTimeFormat=function(a,b,c){var d=i[b];return a.replace(/{H}/g,(c&&c.ampm?"AM/PM":"")+(c&&c["long"]?"hh":"h")).replace(/{YEAR}/g,d.Y).replace(/{MONTH}/g,d.M).replace(/{DAY}/g,d.D).replace(/{HOUR}/g,d.h).replace(/{MINUTE}/g,d.m).replace(/{SECOND}/g,d.s)},m});