define("io.ox/office/tk/object/timermixin",["io.ox/office/tk/utils","io.ox/office/tk/config","io.ox/office/tk/utils/logger"],function(a,b,c){"use strict";function d(){function b(a,b,c){a.abort=function(d){return"pending"===a.state()&&(_.isUndefined(d)&&(d="abort"),_.isFunction(c)&&c.call(this,d),b(d)),this},a.always(function(){a.abort=function(){return this}})}function c(a){var d=_.bind(a.then,a),e=_.bind(a.abort,a);a.then=function(a,f,g,h){var i=d(a,f,g);return b(i,e,h),c(i),i},delete a.pipe}var d=this,g=[];this.createAbortablePromise=function(a,d,e){var f=a.promise();if(b(f,_.bind(a.reject,a),d),c(f),"pending"===f.state()&&(g.push(f),f.always(function(){g=_.without(g,f)}),_.isNumber(e)&&e>0)){var h=window.setTimeout(function(){"pending"===f.state()&&f.abort("timeout")},e);f.always(function(){h&&(window.clearTimeout(h),h=null)})}return d=null,f},this.executeDelayed=function(b,c){var e=_.isNumber(c)?Math.max(0,c):a.getIntegerOption(c,"delay",0,0),f=null,g=$.Deferred(),h=this.createAbortablePromise(g,function(){f&&(window.clearTimeout(f),f=null)});return f=window.setTimeout(function(){f=null,$.when(b.call(d)).done(_.bind(g.resolve,g)).fail(_.bind(g.reject,g))},e),h},this.repeatDelayed=function(b,c,e){function f(){var c=b.call(d,l),e=!1,f=0;return c===a.BREAK?void n.resolve(a.BREAK):(c=$.when(c),e="pending"===c.state(),f=e?_.now():0,c.done(function(){"pending"===n.state()&&(l+=1,!_.isNumber(j)||j>l?g(k&&e?Math.max(0,i-(_.now()-f)):i):n.resolve())}),void c.fail(_.bind(n.reject,n)))}function g(a){m=d.executeDelayed(f,a,e)}var h=_.isNumber(c)?Math.max(0,c):a.getIntegerOption(c,"delay",0,0),i=a.getIntegerOption(c,"repeatDelay",h,0),j=a.getIntegerOption(c,"cycles"),k=a.getBooleanOption(c,"fastAsync"),l=0,m=null,n=$.Deferred(),o=this.createAbortablePromise(n,function(){m&&(m.abort(),m=null)});return"immediate"===a.getStringOption(c,"delay")?f():g(h),o},this.repeatSliced=function(b,c){var e=a.getIntegerOption(c,"slice",200,10),f=a.getStringOption(c,"infoString",""),g=0,h=null,i=$.Deferred(),j=this.createAbortablePromise(i,function(){h&&(h.abort(),h=null)});return h=this.repeatDelayed(function(){var c=_.now(),f=null;for(i.notify(g);;){if(f=b.call(d,g),g+=1,f===a.BREAK)return i.resolve(a.BREAK),a.BREAK;if(_.isObject(f)&&_.isFunction(f.promise)&&"resolved"!==f.state())return f;if(_.now()-c>=e)return}},{delay:a.getOption(c,"delay"),repeatDelay:a.getIntegerOption(c,"interval",10,0),fastAsync:!0},f),h.done(_.bind(i.resolve,i)).fail(_.bind(i.reject,i)),j},this.iterateArraySliced=function(b,c,e){var f=a.getBooleanOption(e,"reverse",!1),g=f?b.length-1:0,h=null,i=$.Deferred(),j=this.createAbortablePromise(i,function(){h&&(h.abort(),h=null)});return 0===b.length?(i.notify(1).resolve(),j):(h=this.repeatSliced(function(){if(0>g||g>=b.length)return i.resolve(),a.BREAK;var e=c.call(d,b[g],g,b);return g=f?g-1:g+1,!(0>g||g>=b.length)||_.isObject(e)&&_.isFunction(e.promise)&&"resolved"!==e.state()?e:(i.resolve(),a.BREAK)},e),h.done(_.bind(i.resolve,i)).fail(_.bind(i.reject,i)),h.progress(function(a){i.notify(a/b.length)}),j.done(function(){i.notify(1)}),j)},this.iterateObjectSliced=function(a,b,c){return this.iterateArraySliced(_.keys(a),function(c){return c in a?b.call(this,a[c],c,a):void 0},c)},this.createSynchronizedMethod=function(b,c){function e(){if(0===g.length)return a.BREAK;var c=g[0],d=$.when(b.apply(c.ctxt,c.args)),e=c.def;return d.always(function(){g.shift()}),d.done(_.bind(e.resolve,e)).fail(_.bind(e.reject,e)),0===g.length?a.BREAK:d}function f(a){_.each(g,function(b){b.def.reject(a)})}var g=[],h=null;return function(){var a={ctxt:this,args:arguments,def:$.Deferred()};return g.push(a),h||(h=d.repeatDelayed(e,{delay:"immediate"},c).fail(f),h.always(function(){h=null})),a.def.promise()}},this.createDebouncedMethod=function(b,c,e){function f(){k&&k.abort(),l&&l.abort(),k=l=null,m=!0}function g(a){function b(){f(),c.call(a)}m&&k&&(k.abort(),k=null),m&&(m=!1,window.setTimeout(function(){m=!0},0)),k||(k=d.executeDelayed(b,h,"debounced (min) "+j)),!l&&i>0&&(l=d.executeDelayed(b,i,"debounced (max) "+j))}var h=a.getIntegerOption(e,"delay",0,0),i=a.getIntegerOption(e,"maxDelay",0,0),j=a.getStringOption(e,"infoString",""),k=null,l=null,m=!0;return function(){return g(this),b.apply(this,arguments)}},e.withLogging(function(){this.executeDelayed=_.wrap(this.executeDelayed,function(a,b,c,d){var g=f,h=_.now();return f+=1,e.log("#"+g+": timer created from "+(d||"<anonymous>")),a.call(this,function(){var a=_.now();e.log("#"+g+": timer fired after "+(a-h)+"ms");var c=b.call(this),d=_.now();return e.log("#"+g+": callback returned after "+(d-a)+"ms"),_.isObject(c)&&_.isFunction(c.promise)&&c.always(function(){e.log("#"+g+": async callback resolved after "+(_.now()-d)+"ms")}),c},c)})},this),this.registerDestructor(function(){for(;g.length>0;)g[0].abort();d=g=null})}var e=new c({prefix:"TIMER",enable:"office:log-timers"}),f=1;return d});